from multiprocessing import Pool
from marionette_harness.runtests import MarionetteTestRunner
from mozlog.structured import commandline
from mozprofile import FirefoxProfile

# Path to a firefox binary.
#BINARY="firefox/firefox"
BINARY="../../areweslimyet/firefox/firefox"

def run_test(port):
    try:
        # Make each instance use different port.
        prefs = {
            "marionette.defaultPrefs.port": port,
        }

        # Setup a runner with an empty profile.
        profile = FirefoxProfile(preferences=prefs)
        logger = commandline.setup_logging("pool test", {})
        runner = MarionetteTestRunner(
                binary=BINARY,
                profile=profile,
                logger=logger,
                gecko_log='gecko-%d.log' % port,
                address="localhost:%d" % port)

        # Run the test.
        runner.run_tests("test_pool_bug.py")
    except:
        import traceback
        traceback.print_exc()
        return False

    return True


if __name__ == '__main__':
    p = Pool(processes=4)
    print p.map(run_test, range(24242, 24246))
    p.close()
    p.join()
